//
//  main.m
//  PDFSplitConsole
//
//  Created by Debenu Pty Ltd on 9/22/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Controller.h"

void printUsage();

int main(int argc, const char * argv[])
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
    
    NSArray* arguments = [[NSProcessInfo processInfo] arguments];
    
    if( [arguments count] != 4 ) {
        printUsage();
        return -1;
    }

    NSString* inputFilePath1 = [arguments objectAtIndex:1];
    NSString* inputFilePath2 = [arguments objectAtIndex:2];
    NSString* outputFilePath = [arguments objectAtIndex:3];
    
    Controller* controller = [[[Controller alloc] init] autorelease];
    NSError* error = nil;

    if( ![controller combineWithFile1:inputFilePath1 file2:inputFilePath2 to:outputFilePath error:&error] ) {
        NSLog(@"%@", [error localizedDescription]);
        return -1;
    }

    NSLog(@"combine pdf success!");
        
    [pool drain];
    
    return 0;
}

void printUsage()
{
    NSLog(@"Usage: pdfcombineconsole input_file1 input_file2 output_file");
}
