//
//  Controller.m
//  PDFSplit
//
//  Created by Debenu Pty Ltd on 9/20/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import "Controller.h"
#import "DebenuPDFLibraryDylibClass1015.h"

@implementation Controller

- (BOOL)drawShapeToFile:(NSString*)toFilePath error:(NSError**)error
{
    // extract text from pdf
    NSBundle* mainBundle = [NSBundle mainBundle];
    NSString* dylibPath = [mainBundle privateFrameworksPath];
    
    dylibPath = [dylibPath stringByAppendingPathComponent:@"libDebenuPDFLibraryDylib1015.dylib"];
    
    DebenuPDFLibraryDylibClass1015* DQPL = [[[DebenuPDFLibraryDylibClass1015 alloc] initWithDylibFileName:dylibPath] autorelease];
    
    NSString* key = @"*** insert your license key here ***";
    
    if( [DQPL UnlockKey:key] != 1 ) {
        
        if( error != NULL ) {
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:[NSString stringWithFormat:@"Failed to unlock DQPL with %@", key] forKey:NSLocalizedDescriptionKey]];

        }
        
        return NO;
    }
    
    /* Draw some shapes on a new PDF */
    // Set the page size for the new PDF
    
    [DQPL SetPageSize:@"A4"];
    
    // Set the origin for the drawing co-ordinates
    // to be the top left corner of the page.
    
    [DQPL SetOrigin:1];
    
    // Set the measurement unit that we'll use.
    // In this example we'll use millimetres.
    
    [DQPL SetMeasurementUnits:1];
    
    // Set the color and the width for the line
    
    [DQPL SetLineColor:255 :0 :0];
    [DQPL SetLineWidth:0.5];
    
    // Create a variety of boxes and circles
    // using a loop.
    
    for( int x = 0; x <= 9; x++ ) {
        
        for( int y = 0; y <= 10; y++ ) {
            
            [DQPL DrawBox:5 + x * 20: 5 + y * 25 :20 :25 :0];
            [DQPL SetFillColor:0 :192 :0];
            [DQPL DrawCircle:15 + x * 20 :17.5 + y * 25 :8 :2];
        }
    }

    // Save the new file to the output folder
    
    if( [DQPL SaveToFile:toFilePath] != 1 ) {
        
        if( error != NULL ) {
            
            NSString* description = [NSString stringWithFormat:@"Failed to save combined PDF to %@", toFilePath];
            
            *error = [NSError errorWithDomain:@"DQPLErrorDomain"
                                         code:0
                                     userInfo:[NSDictionary dictionaryWithObject:description forKey:NSLocalizedDescriptionKey]];
            
        }
        
        return NO;
    }
        
    return YES;
}

@end
