//
//  main.m
//  PDFSplitConsole
//
//  Created by Debenu Pty Ltd on 9/22/12.
//  Copyright (c) 2012 Debenu Pty Ltd. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "Controller.h"

void printUsage();

int main(int argc, const char * argv[])
{
    NSAutoreleasePool* pool = [[NSAutoreleasePool alloc] init];
    
    NSArray* arguments = [[NSProcessInfo processInfo] arguments];
    
    if( [arguments count] < 3 ) {
        printUsage();
        return -1;
    }
    
    NSFileManager* fileManager = [NSFileManager defaultManager];
    NSString* sourceFilePath = [arguments objectAtIndex:1];
    
    BOOL isDirectory;
    BOOL exists = [fileManager fileExistsAtPath:sourceFilePath isDirectory:&isDirectory];
    
    if( !exists || isDirectory ) {
        
        NSLog(@"incorrect source file path.");
        
        printUsage();
        return -1;
    }
    
    NSString* destDirPath = [arguments objectAtIndex:2];
    exists = [fileManager fileExistsAtPath:destDirPath isDirectory:&isDirectory];

    if( !exists || !isDirectory ) {

        NSLog(@"incorrect dest directory path.");
        
        printUsage();
        return -1;
    }

    Controller* splitController = [[[Controller alloc] init] autorelease];
    NSError* error = nil;
    
    if( ![splitController splitFile:sourceFilePath to:destDirPath error:&error] ) {
        NSLog(@"%@", [error localizedDescription]);
        return -1;
    }

    NSLog(@"split success!");
        
    [pool drain];
    
    return 0;
}

void printUsage()
{
    NSLog(@"Usage: pdfsplitconsole source_file_path dest_dir_path");
}
